#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.5
 Author:         Cetipabo

 Script Function:
	Récupérération des données de la BOX SFR NB6VAC lors d'un Telnet sur le port 1287

#ce ----------------------------------------------------------------------------

#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("Telnet BOX SFR", 1027, 437, 192, 124)
$Edit1 = GUICtrlCreateEdit("", 16, 16, 993, 393)
GUICtrlSetData(-1, "")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

TCPStartup ()
$Box = TCPNameToIP ("box")
$Connexion = TCPConnect ( $Box, 1287)
For $i=1 to 1000
$recv = TCPRecv ( $Connexion,2048 )
if $recv <>"" then exitloop
Next

;msgbox(0,"",$recv)
$data = stringsplit($recv,";")

$wanip = StringTrimLeft($data[2],3)
$sfrbox = StringTrimLeft($data[3],3)
$macbox = StringTrimLeft($data[4],3)
$hash = _Base64Decode(StringTrimLeft($data[104],3))

$chaine= ""
For $i = 1 to $data[0]
	if ($i = 104 OR $i = 119 OR $i = 127) Then
		$chaine = $chaine & _Base64Decode(StringTrimLeft($data[$i],3)) & @crlf
	Else
		$chaine = $chaine & StringTrimLeft($data[$i],3) & @crlf
	EndIf
Next
GUICtrlSetData($Edit1,$chaine)
;msgbox(0,"",$hash)



While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit

	EndSwitch
WEnd






Func _Base64Decode($input_string)

    Local $struct = DllStructCreate("int")

    $a_Call = DllCall("Crypt32.dll", "int", "CryptStringToBinary", _
            "str", $input_string, _
            "int", 0, _
            "int", 1, _
            "ptr", 0, _
            "ptr", DllStructGetPtr($struct, 1), _
            "ptr", 0, _
            "ptr", 0)

    If @error Or Not $a_Call[0] Then
        Return SetError(1, 0, "") ; error calculating the length of the buffer needed
    EndIf

    Local $a = DllStructCreate("byte[" & DllStructGetData($struct, 1) & "]")

    $a_Call = DllCall("Crypt32.dll", "int", "CryptStringToBinary", _
            "str", $input_string, _
            "int", 0, _
            "int", 1, _
            "ptr", DllStructGetPtr($a), _
            "ptr", DllStructGetPtr($struct, 1), _
            "ptr", 0, _
            "ptr", 0)

    If @error Or Not $a_Call[0] Then
        Return SetError(2, 0, ""); error decoding
    EndIf

    Return BinaryToString(DllStructGetData($a, 1))

EndFunc   ;==>_Base64Decode https://www.autoitscript.com/forum/topic/81332-_base64encode-_base64decode/